#include "Complex.h"

void add(ComplexT *a, ComplexT *b, ComplexT *c)
/* parameters passed by pointers */
{
	c->re = a->re + b->re;
	c->im = a->im + b->im;
}
void subtract(ComplexT a, ComplexT b, ComplexT *c)
/* input parameters passed by value, allowed in C++ only, and
result passed by pointer */
{
	c->re = a.re - b.re;
	c->im = a.im - b.im;
}
//void multiply(ComplexT a, ComplexT b, ComplexT& c)
//* input parameters passed by value, and
//result passed by void divide(ComplexT *a, ComplexT *b, ComplexT *c)reference, all allowed in C++ only */
//{
//	c.re = a.re * b.re - a.im * b.im;
//	c.im = a.im * b.re + a.re * b.im;
//}
void multiply(ComplexT a, ComplexT b, ComplexT *c)
/* input parameters passed by value, and
result passed by pointer */
{
	c->re = a.re * b.re - a.im * b.im;
	c->im = a.im * b.re + a.re * b.im;
}
void divide(ComplexT *a, ComplexT *b, ComplexT *c)
/* parameters passed by pointers */
{
	float x;

	x = b->re * b->re + b->im * b->im;
	if ( x == 0 )
	{
		puts("\nDivision by zero");
		exit(1);
	}
	else
	{
		c->re = (a->re * b->re + a->im * b->im) / x;
		c->im = (a->im * b->re - a->re * b->im) / x;
	}
}
void readComplex(const char *msg, const char *nbName, ComplexT *nb)
{
	printf("\nPlease input the %s complex number\n\t%s.re=", msg, nbName);
	scanf("%f", &(nb->re));
	printf("\t%s.im=", nbName);
	scanf("%f", &(nb->im));
	getchar();
}
